using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MulticastDelegates
{
    public partial class ChildForm : Form
    {
        public ChildForm()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Handle the Load event for this form.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ChildForm_Load(object sender, EventArgs e)
        {
            // Display the date-and-time of creation, in the caption bar
            this.Text = "Created " + DateTime.Now.ToLongTimeString();
        }


        /// <summary>
        /// This method will be called via multicast delegate in main form.
        /// </summary>
        /// <param name="theColor"></param>
        /// <returns></returns>
        public string Repaint(Color theColor)
        {
            // Set the color for this form, and update the caption bar
            this.BackColor = theColor;
            this.Text = "Updated " + DateTime.Now.ToLongTimeString();
            return this.Text;
        }


        /// <summary>
        /// Handle the Closing event for this form.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ChildForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            // Tell the main form we are closing, so the main form can 
            // remove us from its multicast delegate.
            MainForm MyOwner = (MainForm)this.Owner;
            MyOwner.ChildFormClosing(this);
        }
    }
}